diff -aurN a/CHAP.php b/CHAP.php
--- a/CHAP.php	1970-01-01 04:13:08.000000000 -0500
+++ b/CHAP.php	2018-02-13 13:04:49.812389739 -0500
@@ -78,7 +78,19 @@
      * @var  integer
      */
     var $chapid = 1;
-    
+
+    /**
+     * Constructor
+     *
+     * Generates a random challenge
+     * @return void
+     */
+    function __construct()
+    {
+        parent::__construct();
+        $this->generateChallenge();
+    }
+
     /**
      * Constructor
      *
@@ -160,7 +172,19 @@
      * @var  bool
      */
     var $flags = 1;
-    
+
+    /**
+     * Constructor
+     *
+     * Loads the hash extension
+     * @return void
+     */
+    function __construct()
+    {
+        parent::__construct();
+        $this->loadExtension('hash');        
+    }
+
     /**
      * Constructor
      *
@@ -412,6 +436,19 @@
     /**
      * Constructor
      *
+     * Generates the 16 Bytes peer and authentication challenge
+     * @return void
+     */
+    function __construct()
+    {
+	parent::__construct();
+        $this->generateChallenge('peerChallenge', 16);
+        $this->generateChallenge('authChallenge', 16);
+    }
+
+    /**
+     * Constructor
+     *
      * Generates the 16 Bytes peer and authentication challenge
      * @return void
      */
